///////////////////////////////////////////////////////////////
// Topro PC Camera Parameter Table
///////////////////////////////////////////////////////////////
#ifndef TP_PARAM_H
#define TP_PARAM_H

#include "tp_def.h"

//////////////////////////////////////////////////////////////////////
// EVS Sensor
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_evs_350a[] = { // EVS 350A
	// GPIO
	{GPIO_IO,0x9F},			{GPIO_DATA,0x27},
	{FORMAT,0x00},			{DARK_CFG,0x00},

	// Initialize data
	{SIF_TYPE,0x00},
	{BAD_LOW_THRLD_L,0x00},		{BAD_LOW_THRLD_H,0x00},
	{BAD_HIGH_THRLD_L,0xFF},	{BAD_HIGH_THRLD_H,0x03},
	{EDGE_THRLD,0x40},
	{QUALITY,0x03},			{BLK_THRLD,0x40},
	{TIMING_CFG,0x02},		{SENSOR_CFG,0x10},

	{FRONT_DARK_ST,0x00},		{FRONT_DARK_END,0x00},
	{REAR_DARK_ST_L,0x00},		{REAR_DARK_ST_H,0x00},
	{REAR_DARK_END_L,0x00},		{REAR_DARK_END_H,0x00},
	{HORIZONTAL_DARK_LINE_L,0x00},	{HORIZONTAL_DARK_LINE_H,0x00},
	{VSYNC_EN_PERIOD_L,0xF4},	{VSYNC_EN_PERIOD_H,0x01},
	{VSYNC_DIS_PERIOD,0x28},
	{HSYNC_EN_PERIOD_L,0x1A},	{HSYNC_EN_PERIOD_H,0x03},
	{HSYNC_DIS_PERIOD,0x24},
	{HSYNC_TO_VSYNC_L,0x90},	{HSYNC_TO_VSYNC_H,0x01},
	{ENDP_1_CTL,0x00},

	// VGA
	{DEMOSAIC_CFG,0x0A},
	{PIXEL_START,0x80},		{PIXEL_END_L,0xFF},
	{PIXEL_END_H,0x02},		{LINE_START,0x0D},
	{LINE_END_L,0xED},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_qvga_evs_350a[] = {
	{FORMAT,0x0001},		{DEMOSAIC_CFG,0x000E},

	{END_REG, 0x00}
};

struct topro_sregs topro_sensor_evs_350a[] = {
	{SIF_ADDR_S,0x7f},		{SIF_ADDR_S2,0x00},
	{SIF_TX_DATA,0x00},		{SIF_CONTROL,0x01},

	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// TAS Sensor
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_tas[] = {
	{FORMAT,0x00},			{DARK_CFG,0x00},

	// Initialize data
	{SIF_TYPE,0x01},		{BAD_LOW_THRLD_L,0x00},
	{BAD_LOW_THRLD_H,0x00},		{BAD_HIGH_THRLD_L,0xFF},
	{BAD_HIGH_THRLD_H,0x03},
	{EDGE_THRLD,0x40},
	{QUALITY,0x01},			{BLK_THRLD,0x40},
	{TIMING_CFG,0x1C},		{SENSOR_CFG,0x18},

	{FRONT_DARK_ST,0x00},		{FRONT_DARK_END,0x00},//35
	{REAR_DARK_ST_L,0xC1},		{REAR_DARK_ST_H,0x02},//02C0
	{REAR_DARK_END_L,0xCA},		{REAR_DARK_END_H,0x02},//02C6
	{HORIZONTAL_DARK_LINE_L,0x07},	{HORIZONTAL_DARK_LINE_H,0x90},

	{VSYNC_EN_PERIOD_L,0x0D},
	{VSYNC_EN_PERIOD_H,0x02},	{VSYNC_DIS_PERIOD,0x28},
	{HSYNC_EN_PERIOD_L,0xF0},	{HSYNC_EN_PERIOD_H,0x02},
	{HSYNC_DIS_PERIOD,0x0A},	{HSYNC_TO_VSYNC_L,0x90},
	{HSYNC_TO_VSYNC_H,0x01},	//{ENDP_1_CTL,0x03},

	// VGA
	{DEMOSAIC_CFG,0x0A},
	{PIXEL_START,0x60},		{PIXEL_END_L,0xDF},
	{PIXEL_END_H,0x02},		{LINE_START,0x0E},
	{LINE_END_L,0xEE},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_sensor_tas[] = {
	{SIF_TX_DATA,0x00},		{SIF_TX_DATA2,0x01},
	{SIF_CONTROL,0x01},

	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// Hynix Sensor
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_hynix_7131E1[] =
{
	// GPIO
	{GPIO_IO,0x9F},			{GPIO_DATA,0x27},
	{FORMAT,0x00},			{DARK_CFG,0x00},

	// Initialize data
	{SIF_TYPE,0x00},		{BAD_LOW_THRLD_L,0x00},
	{BAD_LOW_THRLD_H,0x00},		{BAD_HIGH_THRLD_L,0xFF},
	{BAD_HIGH_THRLD_H,0x03},	{DARK_CFG,0x00},
	{EDGE_THRLD,0x40},
	{QUALITY,0x03},			{BLK_THRLD,0x40},
	{TIMING_CFG,0x16},		{SENSOR_CFG,0x18},

	{FRONT_DARK_ST,0x01},		{FRONT_DARK_END,0x01},
	{REAR_DARK_ST_L,0x82},		{REAR_DARK_ST_H,0x02},
	{REAR_DARK_END_L,0x82},		{REAR_DARK_END_H,0x02},
	{HORIZONTAL_DARK_LINE_L,0x02},	{HORIZONTAL_DARK_LINE_H,0x08},

	{END_REG, 0x00}
};

struct topro_sregs topro_vga_hynix_7131E1[] =
{
	{DEMOSAIC_CFG,0x0A},
	{PIXEL_START,0x01},
	{PIXEL_END_L,0x80},		{PIXEL_END_H,0x02},
	{LINE_START,0x03},
	{LINE_END_L,0xE3},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_qvga_hynix_7131E1[] =
{
	{DEMOSAIC_CFG,0x0E},
	{PIXEL_START,0x01},
	{PIXEL_END_L,0x80},		{PIXEL_END_H,0x02},
	{LINE_START,0x03},
	{LINE_END_L,0xE3},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_i2c_hynix_7131E1[] =
{
	// device address  word address       data               command
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x01},{SIF_TX_DATA,0x04},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x02},{SIF_TX_DATA,0x90},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x10},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x11},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x12},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x13},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x14},{SIF_TX_DATA,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x15},{SIF_TX_DATA,0xe4},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x16},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x17},{SIF_TX_DATA,0x84},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x20},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x21},{SIF_TX_DATA,0xa6},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x22},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x23},{SIF_TX_DATA,0x0a},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x25},{SIF_TX_DATA,0x03},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x26},{SIF_TX_DATA,0x0d},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x27},{SIF_TX_DATA,0x40},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x31},{SIF_TX_DATA,0x30},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x32},{SIF_TX_DATA,0x30},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x33},{SIF_TX_DATA,0x30},{SIF_CONTROL,0x01},

	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// Hynix 7131R1 Sensor
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_hynix_7131R1[] =
{
	// GPIO
	{GPIO_IO,0x9F},			{GPIO_DATA,0x27},
	{FORMAT,0x00},			{DARK_CFG,0x00},

	// Initialize data
	{SIF_TYPE,0x00},		{BAD_LOW_THRLD_L,0x00},
	{BAD_LOW_THRLD_H,0x00},		{BAD_HIGH_THRLD_L,0xFF},
	{BAD_HIGH_THRLD_H,0x03},	{DARK_CFG,0x00},
	{EDGE_THRLD,0x40},
	{QUALITY,0x03},			{BLK_THRLD,0x40},
	{TIMING_CFG,0x27},		{SENSOR_CFG,0x00},

	{FRONT_DARK_ST,0x01},		{FRONT_DARK_END,0x01},
	{REAR_DARK_ST_L,0x82},		{REAR_DARK_ST_H,0x02},
	{REAR_DARK_END_L,0x82},		{REAR_DARK_END_H,0x02},
	{HORIZONTAL_DARK_LINE_L,0x02},	{HORIZONTAL_DARK_LINE_H,0x08},

	{END_REG, 0x00}
};

struct topro_sregs topro_vga_hynix_7131R1[] =
{
	{DEMOSAIC_CFG,0x0A},
	{PIXEL_START,0x02},
	{PIXEL_END_L,0x81},		{PIXEL_END_H,0x02},
	{LINE_START,0x02},
	{LINE_END_L,0xE2},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_qvga_hynix_7131R1[] =
{
	{DEMOSAIC_CFG,0x0E},
	{PIXEL_START,0x02},
	{PIXEL_END_L,0x81},		{PIXEL_END_H,0x02},
	{LINE_START,0x02},
	{LINE_END_L,0xE2},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_i2c_hynix_7131R1[] =
{
	// device address  word address       data               command
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x01},{SIF_TX_DATA,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x02},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x03},{SIF_TX_DATA,0x04},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x10},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x11},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x12},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x13},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x14},{SIF_TX_DATA,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x15},{SIF_TX_DATA,0xe5},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x16},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x17},{SIF_TX_DATA,0x86},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x30},{SIF_TX_DATA,0x08},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x11},{SIF_ADDR_S2,0x40},{SIF_TX_DATA,0xff},{SIF_CONTROL,0x01},

	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// Pixart PAS302 Sensor
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_pixart_PAS302[] =
{
	// GPIO
	{GPIO_IO,0x9F},			{GPIO_DATA,0x27},
	{FORMAT,0x00},			{DARK_CFG,0x00},

	// Initialize data
  {SIF_TYPE,0x01}, {SIF_CONTROL,0x01},
	{SIF_TYPE,0x00},		{BAD_LOW_THRLD_L,0x00},
	{BAD_LOW_THRLD_H,0x00},		{BAD_HIGH_THRLD_L,0xFF},
	{BAD_HIGH_THRLD_H,0x03},	{DARK_CFG,0x00},
	{EDGE_THRLD,0x40},
	{QUALITY,0x03},			{BLK_THRLD,0x40},
	{TIMING_CFG,0x17},		{SENSOR_CFG,0x18},

	{FRONT_DARK_ST,0x01},		{FRONT_DARK_END,0x01},
	{REAR_DARK_ST_L,0x82},		{REAR_DARK_ST_H,0x02},
	{REAR_DARK_END_L,0x82},		{REAR_DARK_END_H,0x02},
	{HORIZONTAL_DARK_LINE_L,0x02},	{HORIZONTAL_DARK_LINE_H,0x08},

	{END_REG, 0x00}
};

struct topro_sregs topro_vga_pixart_PAS302[] =
{
	{DEMOSAIC_CFG,0x0A},
	{PIXEL_START,0x02},
	{PIXEL_END_L,0x81},		{PIXEL_END_H,0x02},
	{LINE_START,0x05},
	{LINE_END_L,0xE6},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_qvga_pixart_PAS302[] =
{
	{DEMOSAIC_CFG,0x0E},
	{PIXEL_START,0x02},
	{PIXEL_END_L,0x81},		{PIXEL_END_H,0x02},
	{LINE_START,0x05},
	{LINE_END_L,0xE6},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_i2c_pixart_PAS302[] =
{
	// device address  word address       data               command
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x02},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x03},{SIF_TX_DATA,0x57},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x04},{SIF_TX_DATA,0x07},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x05},{SIF_TX_DATA,0x27},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x06},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x07},{SIF_TX_DATA,0x05},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x08},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x09},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x0a},{SIF_TX_DATA,0x3c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x0b},{SIF_TX_DATA,0x1e},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x0c},{SIF_TX_DATA,0x06},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x0d},{SIF_TX_DATA,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x0e},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x0f},{SIF_TX_DATA,0x5c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x10},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x12},{SIF_TX_DATA,0x07},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x13},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x14},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x15},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x16},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x17},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x18},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x19},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x1a},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x1b},{SIF_TX_DATA,0x03},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x1c},{SIF_TX_DATA,0xa0},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x1d},{SIF_TX_DATA,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x1e},{SIF_TX_DATA,0xf3},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x1f},{SIF_TX_DATA,0x21},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x20},{SIF_TX_DATA,0x31},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x21},{SIF_TX_DATA,0x03},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x22},{SIF_TX_DATA,0x10},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x23},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x24},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x26},{SIF_TX_DATA,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x27},{SIF_TX_DATA,0x22},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x28},{SIF_TX_DATA,0xcb},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x29},{SIF_TX_DATA,0x90},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x2a},{SIF_TX_DATA,0x26},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x2b},{SIF_TX_DATA,0x70},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x2c},{SIF_TX_DATA,0x04},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x2d},{SIF_TX_DATA,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x40},{SIF_ADDR_S2,0x11},{SIF_TX_DATA,0x01},{SIF_CONTROL,0x01},

	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// Micron Sensor
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_micron_MT9V011[] =
{
	// GPIO
	{GPIO_IO,0x9F},			              {GPIO_DATA,0x07},
	{FORMAT,0x00},			              {DARK_CFG,0x00},

	// Initialize data


  {SIF_TYPE,0x04},									{BAD_LOW_THRLD_L,0x00},
  {BAD_LOW_THRLD_H,0x00},						{BAD_HIGH_THRLD_L,0xFF},
  {BAD_HIGH_THRLD_H,0x03},					{DARK_CFG,0x00},
  {EDGE_THRLD,0x40},
  {QUALITY,0x03},										{BLK_THRLD,0x40},
  {TIMING_CFG,0x27},	              {SENSOR_CFG,0x00},
  {FRONT_DARK_ST,0x00},							{FRONT_DARK_END,0x00},
  {REAR_DARK_ST_L,0x00},						{REAR_DARK_ST_H,0x00},
  {REAR_DARK_END_L,0x00},						{REAR_DARK_END_H,0x00},
  {HORIZONTAL_DARK_LINE_L,0x00},		{HORIZONTAL_DARK_LINE_H,0x00},
//  {ENDP_1_CTL,0x03},                {FRAME_RATE,0x87},

	{END_REG, 0x00}
  
};

struct topro_sregs topro_vga_micron_MT9V011[] =
{
	{DEMOSAIC_CFG,0x0A},
	{PIXEL_START,0x02}, 	{PIXEL_END_L,0x81},		{PIXEL_END_H,0x02},
	{LINE_START,0x03},  	{LINE_END_L,0xE4},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_qvga_micron_MT9V011[] =
{
	{DEMOSAIC_CFG,0x0E},
	{PIXEL_START,0x02},	{PIXEL_END_L,0x81},   {PIXEL_END_H,0x02},
	{LINE_START,0x03},	{LINE_END_L,0xE4},		{LINE_END_H,0x01},

	{END_REG, 0x00}
};

struct topro_sregs topro_i2c_micron_MT9V011[] =
{
	// device address  word address       data               command
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x07},{SIF_TX_DATA,0x30},{SIF_TX_DATA2,0x03},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x01},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x08},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x02},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x14},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x03},{SIF_TX_DATA,0x01},{SIF_TX_DATA2,0xe6},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x04},{SIF_TX_DATA,0x02},{SIF_TX_DATA2,0x86},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x05},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x20},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x06},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x0c},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x09},{SIF_TX_DATA,0x01},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x0a},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x02},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x0b},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x0c},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x0d},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x1e},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x20},{SIF_TX_DATA,0x11},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x27},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x24},{SIF_CONTROL,0x01},

  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x2b},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x2c},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x2d},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x2e},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x35},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x30},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x3e},{SIF_TX_DATA,0x08},{SIF_TX_DATA2,0x21},{SIF_CONTROL,0x01},

  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x30},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x06},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x31},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x32},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x34},{SIF_TX_DATA,0x01},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x41},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0xd1},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x42},{SIF_TX_DATA,0x08},{SIF_TX_DATA2,0x82},{SIF_CONTROL,0x01},

  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x58},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x78},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x59},{SIF_TX_DATA,0x07},{SIF_TX_DATA2,0x03},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x5b},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x5c},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x5d},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x5e},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x5f},{SIF_TX_DATA,0xa3},{SIF_TX_DATA2,0x1d},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x60},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x61},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x62},{SIF_TX_DATA,0x04},{SIF_TX_DATA2,0x11},{SIF_CONTROL,0x01},
  {SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x63},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x64},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x00},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0xf1},{SIF_TX_DATA,0x00},{SIF_TX_DATA2,0x01},{SIF_CONTROL,0x01},
	{SIF_ADDR_S,0x5d},{SIF_ADDR_S2,0x07},{SIF_TX_DATA,0x30},{SIF_TX_DATA2,0x02},{SIF_CONTROL,0x01},

	{END_REG, 0x00}
};

//////////////////////////////////////////////////////////////////////
// Sharp CCD Sensor
//////////////////////////////////////////////////////////////////////
struct topro_sregs topro_init_SharpCCD[] =
{
  {SIF_TYPE,0x01},			{BAD_LOW_THRLD_L,0x00},
  {BAD_LOW_THRLD_H,0x00},			{BAD_HIGH_THRLD_L,0xFF},
  {BAD_HIGH_THRLD_H,0x03},		{DARK_CFG,0x00},
  {EDGE_THRLD,0x40},
  {QUALITY,0x03},				{BLK_THRLD,0x40},
  {TIMING_CFG,0x17},

  {SENSOR_CFG,0x18},

  {FRONT_DARK_ST,0x00},			{FRONT_DARK_END,0x00},
  {REAR_DARK_ST_L,0x00},			{REAR_DARK_ST_H,0x00},
  {REAR_DARK_END_L,0x00},			{REAR_DARK_END_H,0x00},
  {HORIZONTAL_DARK_LINE_L,0x00},		{HORIZONTAL_DARK_LINE_H,0x00},
  {ENDP_1_CTL,0x03},
  {FRAME_RATE,0x86},
 
	{END_REG, 0x00}

};

struct topro_sregs topro_vga_SharpCCD[] =
{

	{DEMOSAIC_CFG,0x0A},
	{PIXEL_START,0x4D},            {PIXEL_END_L,0xCC},    {PIXEL_END_H,0x02},
	{LINE_START,0x26},             {LINE_END_L,0x06},     {LINE_END_H,0x02},
  
  {END_REG, 0x00}
};

struct topro_sregs topro_qvga_SharpCCD[] =
{
  {DEMOSAIC_CFG,0x0E},
	{PIXEL_START,0x3D},            {PIXEL_END_L,0xBC},    {PIXEL_END_H,0x02},
	{LINE_START,0x1A},             {LINE_END_L,0xFA},     {LINE_END_H,0x01},


	{END_REG, 0x00}
};

unsigned char topro_i2c_SharpCCD[] =
{
  0xff,
};

//////////////////////////////////////////////////////////////////////
// GAIN
//////////////////////////////////////////////////////////////////////
unsigned char new_gain[] =
{
#if 0
	// Y Gain
	0x5f,0x00,
	0x9f,0x00,
	0x65,0x00,

	// U Gain
	0xac,0x03,
	0xc5,0x02,
	0x97,0x01,

	// V Gain
	0x18,0x01,
	0xee,0x02,
	0xf2,0x03

#elif 0

	// Y Gain
	0x4d,0x00,
	0x96,0x00,
	0x1d,0x00,

	// U Gain
	0xd5,0x03,
	0xab,0x03,
	0x80,0x00,

	// V Gain
	0x80,0x00,
	0x95,0x03,
	0xeb,0x03
	
#elif TP6800_MT9VO11	//MT9V011

	// Y Gain
	0x4d,0x00,
	0x96,0x00,
	0x1d,0x00,

	// U Gain
	0xa9,0x03,
	0x55,0x03,
	0x00,0x01,

	// V Gain
	0x00,0x01,
	0x29,0x03,
	0xd7,0x03
#elif TP6800_SHARPCCD
  0x4d,0x00,
  0x96,0x00,
  0x1d,0x00,
  
  0xca,0x03,
  0x96,0x03,
  0xa0,0x00,

  0xa0,0x00,
  0x7a,0x03,
  0xe6,0x03
#elif TP6800_HV7131R	//7131R

	// Y Gain
	0x4d,0x00,
	0x96,0x00,
	0x1d,0x00,

	// U Gain
	0xb5,0x03,
	0x6b,0x03,
	0xe0,0x00,

	// V Gain
	0xe0,0x00,
	0x45,0x03,
	0xdb,0x03

#elif TP6800_PAS302
  0x4d , 0x00 , 0x96 , 0x00 , 0x1d , 0x00 ,
  0xb5 , 0x03 , 0x6b , 0x03 , 0xe0 , 0x00 ,
  0xe0 , 0x00 , 0x45 , 0x03 , 0xdb , 0x03
  
#else // TAS

	// Y Gain
	0x59,0x00,
	0xc7,0x00,
	0x42,0x00,

	// U Gain
	0x90,0x03,
	0x18,0x03,
	0x60,0x01,

	// V Gain
	0x00,0x01,
	0x05,0x03,
	0xda,0x03

#endif
};

#endif


